#!/usr/bin/env python

import wave, struct
SAMPLE_RATE = 96000 
TRIANGLE=2222.0 # Hz

original = wave.open("sine.wav", "r")

filtered = wave.open("pwm.wav", "w")
filtered.setnchannels(1)
filtered.setsampwidth(2)
filtered.setframerate(SAMPLE_RATE)

tri = wave.open("tri.wav", "w")
tri.setnchannels(1)
tri.setsampwidth(2)
tri.setframerate(SAMPLE_RATE)

n = original.getnframes()
original = struct.unpack('%dh' % n, original.readframes(n))
original = [s / 2.0**15 for s in original]

result = []
triangle = []
trivalue = 0.0
tristep = TRIANGLE / SAMPLE_RATE * 2.0

for i in range(0, len(original)):
	if original[i] > trivalue:
		result.append(+0.8)
	else:
		result.append(-0.8)
	triangle.append(trivalue)
	trivalue += tristep
	if trivalue > 1.0:
		tristep *= -1
		excess = trivalue - 1.0
		trivalue -= excess * 2
	elif trivalue < -1.0:
		tristep *= -1
		excess = trivalue + 1.0
		trivalue -= excess * 2

result = [ sample * 2.0**15 for sample in result ]
triangle = [ sample * 2.0**15 for sample in triangle ]
filtered.writeframes(struct.pack('%dh' % len(result), *result))
tri.writeframes(struct.pack('%dh' % len(triangle), *triangle))
